
diaryServices.factory('DiaryFactory', function ($q, $http, Configuration, $log,$filter) {
    
    
    var removeRowsWithDrivers = function( requests ){
        console.log("This is the factory requests")
        console.log(requests)
      var filteredRequests = [];
       angular.forEach(requests, function(each){
           console.log("in the for loop");
           console.log(each);
            if( each.driver == null ){
                console.log("in the if statement")
                    filteredRequests.push(each);
                    console.log("this is the filtered list");
                    console.log(filteredRequests);
            };
        });
      
      
      return filteredRequests;
    };
    
    
    var removeRowsWithoutDrivers = function( requests ){
        console.log("This is the factory requests")
        console.log(requests)
      var filteredRequests = [];
       angular.forEach(requests, function(each){
           console.log("in the for loop");
           console.log(each);
            if( each.driver != null ){
                console.log("in the if statement")
                    filteredRequests.push(each);
                    console.log("this is the filtered list");
                    console.log(filteredRequests);
            };
        });
      
      
      return filteredRequests;
    };
    
     return{
       
       removeRowsWithDrivers : removeRowsWithDrivers,
       removeRowsWithoutDrivers: removeRowsWithoutDrivers
    };
});


diaryServices.factory('DiaryService', function ($q, $http, Configuration, $log,$filter) {


    var getCustomers = function () {
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get customers");
        $http.get(Configuration.getConfiguration().customerListUrl).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };


    var getSites = function (cust) {
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get sites");
        $http.get(Configuration.getConfiguration().siteListUrl + cust).then(function (data) {
            $log.info(data);
            
            
            
            
            
                    
//            angular.forEach(data.data,function(each){
//               each.name =  $filter('split')(each.address,'\n',0);
//            });
            
            // add the "A New Site" row to start of combo
            //var newSite = {id:0,name:'A New Site',address:'',lat:0,lng:0,postcode:null,active:true,businessEntityId:0};
            
            //data.data.unshift(newSite);
            
            
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };

    var getActionTypes = function () {
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get ActionTypes");
        $http.get(Configuration.getConfiguration().actionTypeListUrl).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };

    var getPriorities = function () {
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get Priorities");
        $http.get(Configuration.getConfiguration().priorityListUrl).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };
    
    var getRequestTypes = function () {
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get Request Types");
        $http.get(Configuration.getConfiguration().requestTypeUrl).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };
    
    

    var getRequests = function () {
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get Request");
        $http.get(Configuration.getConfiguration().requestListUrl).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };

    var getContacts = function (cust) {
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get Contacts");
        $http.get(Configuration.getConfiguration().contactListUrl + cust).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };

    var getRunCategories = function () {
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get Categories");
        $http.get(Configuration.getConfiguration().runCategoryListUrl).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };

    var getEmployees = function () {
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get Employees");
        $http.get(Configuration.getConfiguration().employeeListUrl).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;
    };


    var createRequest = function (request) {
        //var databaseDoc = angular.copy(data.doc);

        console.log("syncing document");
        console.log(request);
        var documentPostPromise = $q.defer();
        $http({method: 'POST', data: request, url: Configuration.getConfiguration().createRequestUrl}).
                success(function (data, status, headers, config) {
                    //console.log("Success , synced doc to backend");

                    // only remove document from list on a status = 'SUCCESS' response from server
                    //console.log(databaseDoc);
                    //console.log("sync returnDTO");
                    console.log(data);

                    if (data.status === 'SUCCESS') {
                        //For Test only saves me continually creating documents to sync
                        console.log("Sync Successful");
                        documentPostPromise.resolve(data);

                    } else {
                        console.log("sync Failure");
                        documentPostPromise.reject(data);

                    }

                }).
                error(function (data, status, headers, config) {
                    console.log("sync Failure");
                    documentPostPromise.reject(data);

                });

        return documentPostPromise.promise;
    };

    var deleteRequest = function (request) {
        //var databaseDoc = angular.copy(data.doc);

        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get Employees");
        $http.get(Configuration.getConfiguration().deleteRequestUrl + request).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;

    };

    var createAction = function (action) {
        //var databaseDoc = angular.copy(data.doc);

        console.log("syncing document");
        console.log(action);
        var documentPostPromise = $q.defer();
        $http({method: 'POST', data: action, url: Configuration.getConfiguration().createActionListUrl}).
                success(function (data, status, headers, config) {
                    //console.log("Success , synced doc to backend");

                    // only remove document from list on a status = 'SUCCESS' response from server
                    //console.log(databaseDoc);
                    //console.log("sync returnDTO");
                    //console.log(data);

                    if (data.status === 'SUCCESS') {
                        //For Test only saves me continually creating documents to sync
                        console.log("Sync Successful");
                        documentPostPromise.resolve(true);

                    } else {
                        console.log("sync Failure");
                        documentPostPromise.reject(true);

                    }

                }).
                error(function (data, status, headers, config) {
                    console.log("sync Failure");
                    documentPostPromise.reject(true);

                });

        return documentPostPromise.promise;
    };

    var deleteAction = function (action) {
        //var databaseDoc = angular.copy(data.doc);

        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get delete action");
        $http.get(Configuration.getConfiguration().deleteActionUrl + action).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;

    };
    
    
    var requestSearch = function (filter) {
        //var databaseDoc = angular.copy(data.doc);

        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get search requests");
        $http.post(Configuration.getConfiguration().requestSearchUrl, filter).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;

    };
    
    var buildContact = function (contact, contactDetails){
        var getPromise = $q.defer();
        
        var contactBean  = {};
        $log.info("the contact details are");
        $log.info(contactDetails);
        //Checking for nulls
        
        
        if(contactDetails.email == null)
        {
           contactDetails.email = {};
           contactDetails.email.detailData = null;
           contactDetails.email.id = null;
        }
        else if(contactDetails.email.id == null){
            contactDetails.email.id = 0;
        }
        if(contactDetails.phone == null)
        {
           contactDetails.phone = {};
           contactDetails.phone.detailData = null;
           contactDetails.phone.id = null;
        }else if(contactDetails.phone.id == null){
            contactDetails.phone.id = 0;
        }
        if(contactDetails.mobile == null)
        {
           contactDetails.mobile = {};
           contactDetails.mobile.detailData = null;
           contactDetails.mobile.id = null;
        }else if(contactDetails.mobile.id == null){
            contactDetails.mobile.id = 0;
        }
        if(contactDetails.fax == null)
        {
           contactDetails.fax = {};
           contactDetails.fax.detailData = null;
           contactDetails.fax.id = null;
        }else if(contactDetails.fax.id == null){
            contactDetails.fax.id = 0;
        }
        
        if (contact.id != null){
            contactBean = contact;
            contactBean.contactDetails = [{
            contactDetailCategoryId: {
                id:1
            },           
            detailData: contactDetails.email.detailData,
            id : contactDetails.email.id
        },
        {
            contactDetailCategoryId: {
                id:2
            },
            detailData: contactDetails.phone.detailData,
            id : contactDetails.phone.id
        },
        {
            contactDetailCategoryId: {
                id:3
            },
            detailData: contactDetails.mobile.detailData,
            id : contactDetails.mobile.id
        },
        {
            
            contactDetailCategoryId: {
                id:4
            },
            detailData: contactDetails.fax.detailData,
            id : contactDetails.fax.id
        },
            
        ];
            
        }
        else{
        contactBean.name = contact;
        contactBean.id = 0;
        
        contactBean.contactDetails = [{
            contactDetailCategoryId: {
                id:1
            },           
            detailData: contactDetails.email.detailData,
            id: 0
        },
        {
            contactDetailCategoryId: {
                id:2
            },
            detailData: contactDetails.phone.detailData,
            id: 0
        },
        {
            contactDetailCategoryId: {
                id:3
            },
            detailData: contactDetails.mobile.detailData,
            id: 0
        },
        {
            
            contactDetailCategoryId: {
                id:4
            },
            detailData: contactDetails.fax.detailData,
            id: 0
        },
            
        ];
    }
        getPromise.resolve(contactBean);
         $log.info("data creating the contact bean");
          $log.info(contactBean);
        return getPromise.promise;
    };
    
    
     var buildNewSite = function (address){
        var getPromise = $q.defer();
        
        var siteBean  = {};
        siteBean.address = address;
        siteBean.id = 0;
        siteBean.active = true;
        
        
            
        
        getPromise.resolve(siteBean);
         $log.info("data creating the site bean");
          $log.info(siteBean);
        return getPromise.promise;
    };
    
    var buildNewBusiness = function (address, name){
        var getPromise = $q.defer();
        
        var businessBean  = {};
        businessBean.address = address;
        businessBean.id = 0;
        businessBean.name = name;
        
        
            
        
        getPromise.resolve(businessBean);
         $log.info("data creating the business bean");
          $log.info(businessBean);
        return getPromise.promise;
    };
    
    var getLastAction = function (requests) {
        
        console.log("this is the requests to be looked at");
        console.log(requests);
        var requestCount = 0;
        var actionCount = 0;
        
        
        
        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get sites");
        
            
            while (requestCount < requests.length)
                      
        {

            if (requests[requestCount].actions.length > 0){
                            requests[requestCount].currentAction = requests[requestCount].actions[requests[requestCount].actions.length - 1];

                for ( var actionCount = 0; actionCount < requests[requestCount].actions.length; actionCount ++)
                {
                   if(requests[requestCount].actions[actionCount].dateCompleted == null){
                   requests[requestCount].currentAction = requests[requestCount].actions[actionCount];
                   break
                   } 
                }
                /*if (requests[requestCount].actions[requests[requestCount].actions.length - 1].success === true) {
                    requests[requestCount].currentAction = requests[requestCount].actions[requests[requestCount].actions.length - 1];
                }*/
        }
            requestCount ++;
        }
            
            
            console.log("here are the returns requests");
            console.log(requests);
                    
//            angular.forEach(data.data,function(each){
//               each.name =  $filter('split')(each.address,'\n',0);
//            });
            
            // add the "A New Site" row to start of combo
            //var newSite = {id:0,name:'A New Site',address:'',lat:0,lng:0,postcode:null,active:true,businessEntityId:0};
            
            //data.data.unshift(newSite);
            
            
            getPromise.resolve(requests); // return token
        

        return getPromise.promise;
    };
    


    return{
        getCustomers: getCustomers,
        getSites: getSites,
        getPriorities: getPriorities,
        getActionTypes: getActionTypes,
        getRequests: getRequests,
        getContacts: getContacts,
        getRunCategories: getRunCategories,
        createRequest: createRequest,
        deleteRequest: deleteRequest,
        getEmployees: getEmployees,
        createAction: createAction,
        deleteAction: deleteAction,
        requestSearch: requestSearch,
        getRequestTypes: getRequestTypes,
        buildContact: buildContact,
        buildNewSite: buildNewSite,
        buildNewBusiness: buildNewBusiness,
        getLastAction: getLastAction

    };
});


